poj 2192 Zipper

题目链接:http://poj.org/problem?id=2192

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 18658   Accepted: 6651

Description

Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order.

For example, consider forming "tcraete" from "cat" and "tree":

String A: cat 
String B: tree 
String C: tcraete

As you can see, we can form the third string by alternating characters from the two strings. As a second example, consider forming "catrtee" from "cat" and "tree":

String A: cat 
String B: tree 
String C: catrtee

Finally, notice that it is impossible to form "cttaree" from "cat" and "tree".

Input

The first line of input contains a single positive integer from 1 through 1000. It represents the number of data sets to follow. The processing for each data set is identical. The data sets appear on the following lines, one data set per line.

For each data set, the line of input consists of three strings, separated by a single space. All strings are composed of upper and lower case letters only. The length of the third string is always the sum of the lengths of the first two strings. The first two strings will have lengths between 1 and 200 characters, inclusive.

Output

For each data set, print:

Data set n: yes

if the third string can be formed from the first two, or

Data set n: no

if it cannot. Of course n should be replaced by the data set number. See the sample output below for an example.

Sample Input

3
cat tree tcraete
cat tree catrtee
cat tree cttaree

Sample Output

Data set 1: yes
Data set 2: yes
Data set 3: no

Source

Pacific Northwest 2004

题目大意:

给出两串,从两个串取出字符重新组合,看能否组成第三个串。要求:从第一个串取出的字符在第三个串中的顺序不变,第二个串取出的字符在第三个串中的顺序也不变。

算法分析:

此题深搜和DP都能解决:

深搜的话需要几个强有力剪枝条件

1、  第三个串最后一个字符要么是串1的最后一个字符,要么是串2的最后一个字符

2、  按照串1的顺序对串3进行搜索,若不匹配则该字符必是串2的下一个字符。

参考来源:http://www.cnblogs.com/yu-chao/archive/2012/02/26/2369052.html

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstring>
 4 using namespace std;
 5 char first[202],second[202],third[402],Left[401];
 6 int sign[402];
 7 bool flag;
 8 int check()
 9 {
10     int i,count=0;
11     int k=strlen(third);
12     for(i=0;i<k;i++)
13         if(!sign[i]) Left[count++]=third[i];
14     Left[count]=‘\0‘;
15     if(strcmp(Left,second)==0) return 1;
16     return 0;
17 }
18 int dfs(int f,int s,int t)
19 {
20     if(f>=strlen(first))
21     {
22         if(check()) flag=true;
23         return 0;
24     }
25     if(flag) return 0;
26     if(first[f]==third[s])
27     {
28         sign[s]=1;
29         if(s<strlen(third)) dfs(f+1,s+1,t);
30         sign[s]=0;
31     }
32     else
33     {
34         if(third[s]!=second[t]) return 0;//剪枝2
35     }
36     if(!flag && s<strlen(third)) dfs(f,s+1,t+1);
37     return 0;
38 }
39 int main()
40 {
41     int len1,len2,len3,Case,count=0;
42     scanf("%d",&Case);
43     while(Case--)
44     {
45         count++;
46         flag=false;
47         scanf("%s %s %s",first,second,third);
48         memset(sign,0,sizeof(sign));
49
50         len1=strlen(first);
51         len2=strlen(second);
52         len3=strlen(third);
53
54         if(len1+len2!=len3)
55         {
56             printf("Data set %d: no\n",count);
57             continue;
58         }
59         if(third[len3-1]!=first[len1-1] && third[len3-1]!=second[len2-1])// 剪枝1
60         {
61             printf("Data set %d: no\n",count);
62             continue;
63         }
64         dfs(0,0,0);
65         if(flag)
66             printf("Data set %d: yes\n",count);
67         else
68             printf("Data set %d: no\n",count);
69     }
70     return 0;
71 }

动规算法:(参考来源

最优子结构分析:如上例,如果A、B可以组成C,那么,C最后一个字母,必定是 A 或 B 的最后一个字母组成。

C去除除最后一位,就变成是否可以求出 A-1和B 或者 A与B-1 与 是否可以构成 C-1。。。

状态转移方程:

用f[i][j] 表示 表示A前 i 为 和B 前j 位是否可以组成 C的前i+j位        

        dp[i][j]= (dp[i-1][j]&&(a[i]==c[i+j]))||(dp[i][j-1]&&(b[j]==c[i+j]))

 1 #include<stdio.h>
 2 #include<string.h>
 3
 4 char a[201],b[201],c[402];
 5 int la,lb,lc;
 6 int dp[201][201];
 7
 8 int main()
 9 {
10     int ncase;
11     scanf("%d",&ncase);
12     for(int n=1; n<=ncase; n++) {
13
14         a[0]=‘p‘;
15         b[0]=‘p‘;
16         c[0]=‘p‘;
17
18         scanf("%s%s%s",a+1,b+1,c+1);
19
20         la=strlen(a);
21         lb=strlen(b);
22         lc=strlen(c);
23
24         la-=1;
25         lb-=1;
26
27         //处理边界
28         for (int i=1; i<=la; i++)
29             if (a[i]==c[i]) dp[i][0]=1;
30
31         for (int i=1; i<=lb; i++)
32             if (b[i]==c[i]) dp[0][i]=1;
33         //DP
34         for (int i=1; i<=la; i++)
35             for (int j=1; j<=lb; j++)
36                 dp[i][j]= (dp[i-1][j]&&(a[i]==c[i+j]))||(dp[i][j-1]&&(b[j]==c[i+j]));
37
38         printf("Data set %d: ",n);
39         if (dp[la][lb]==1) printf("yes\n");
40         else printf("no\n");
41
42     }
43 }

虽然代码简洁明了易理解,但是个人感觉下面的代码更准确一些。

来源:http://www.cnblogs.com/yu-chao/archive/2012/02/26/2369052.html

若用DP来作先定义res[i][j]=1表示串1前i个字符和串2的前j个字符能组成串3的前i+j个字符,res[i][j]=0则不能。

状态转移方程如下:

Res[i][j]= (third[i+j]==first[i] && res[i-1][j]==1) ||(third[i+j]==second[j]&&res[i][j-1]==1)

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstring>
 4 using namespace std;
 5 char first[201],second[201],third[401];
 6 int res[201][201];
 7 int init(int n,int m)
 8 {
 9     int i;
10     for(i=1;i<=m;i++)
11         if(second[i]==third[i]) res[0][i]=1;
12         else break;
13     for(i=1;i<=n;i++)
14         if(first[i]==third[i]) res[i][0]=1;
15         else break;
16     return 0;
17 }
18 int dp(int n,int m)
19 {
20     int i,j;
21     for(i=1;i<=n;i++)
22         for(j=1;j<=m;j++)
23         {
24             if(third[i+j]==first[i] && res[i-1][j]) res[i][j]=1;
25             if(third[i+j]==second[j] && res[i][j-1]) res[i][j]=1;
26         }
27     if(res[n][m]) return 1;
28     return 0;
29 }
30 int main()
31 {
32     int n,len1,len2,count=0;;
33     scanf("%d",&n);
34     while(n--)
35     {
36         count++;
37         scanf("%s %s %s",first+1,second+1,third+1);
38         len1=strlen(first+1);
39         len2=strlen(second+1);
40         memset(res,0,sizeof(res));
41         init(len1,len2);
42
43         if(dp(len1,len2))
44             printf("Data set %d: yes\n",count);
45         else
46             printf("Data set %d: no\n",count);
47     }
48     return 0;
49 }

时间: 2024-10-14 08:27:01

poj 2192 Zipper的相关文章

poj 2192 Zipper(区间dp)

题目链接:http://poj.org/problem?id=2192 思路分析:该问题可以看做dp问题,同时也可以使用dfs搜索求解,这里使用dp解法: 设字符串StrA[0, 1, …, n]和StrB[0,1, .., m]构成字符串Str[0, 1, … , m + n + 1]; 1)状态定义:dp[i, j]表示字符串StrA[0, 1, …, i-1]和字符串StrB[0, 1, .., j-1]构成字符串Str[0, 1, …, i+j-1]: 2)状态转移:如果dp[i-1][

POJ 2192 Zipper (dp)

链接: http://poj.org/problem?id=2192 题意:就是给定三个字符串A,B,C:判断C能否由AB中的字符组成,同时这个组合后的字符顺序必须是A,B中原来的顺序,不能逆序:例如:A:mnl,B:xyz:如果C为mnxylz,就符合题意:如果C为mxnzly,就不符合题意,原因是z与y顺序不是B中顺序. DP求解:定义dp[i][j]表示A中前i个字符与B中前j个字符是否能组成C中的前 (i+j) 个字符,如果能,标记1,如果不能,标记0: 有了这个定义,我们就可以找出状态

POJ - 2192 - Zipper (简单DP)

题目传送:Zipper 思路:设状态dp[i][j]为字符串A前i个字符和B前j个字符能否组成C的前i+j个字符,边界为dp[0][0] = 1能则为true,否则false AC代码: #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #include <cmath> #include <queue> #include <

ACM POJ 2192 Zipper

题目大意:输入字符串a,b,c 要求判断c是否有a,b中的个字符保持原有顺序组合而成. 算法思想: DP 用dp[i][j]表示a的前0~i-1共i个字符和b的前0~j-1共j个字符是否构成c[i+j-1]. 状态转换方程: if(i>=1&&c[i+j-1]==a[i-1]) dp[i][j]=dp[i][j]||dp[i-1][j] if(j>=1&&c[i+j-1]==b[j-1]) dp[i][j]=dp[i][j]||dp[i][j-1] 代码如下:

POJ 2192 &amp;&amp; HDU 1501 Zipper (记忆化搜索)

Zipper Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 16803   Accepted: 5994 Description Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first tw

POJ 2192 :Zipper(DP)

恢复 DP一直以来都没怎么看,觉得很难,也只会抄抄模板和处理一些简单的背包.于是比赛出现了这道比较简单的题还是不会,要开始去学学DP了. 题意:给出3个字符串,分别为A串和B串还有C串,题目保证A的长度+B的长度=C的长度,C里面包含着A和B的字符,然后判断A和B在C里面的字符顺序还是不是和原来的A和B保持原样. 查看题目 做法:建立一个DP数组dp[i][j],第一维i表示使用了A的前i个字符,第二维j表示使用了B的前j个字符,然后赋予1或者0判断是否可以组成.如果此时c[i+j]==a[i]

POJ 2192 【DP】

题意: 给三个字符串,判断前两个在相对顺序不变的情况下是否可以组成第三个字符串. 思路: 先说屌丝: dp[i][j]代表1串的前i个和2串的前j个字符在3串的前i+j个字符中最多能够组合出几个字符. 然后状态转移是: 如果stra[i]==strc[i+j]则,dp[i][j]=max(dp[i][j],dp[i-1][j]+1) 同样的若strb[i]==strc[i+j]则,dp[i][j]=max(dp[i][j],dp[i][j-1]+1) 最后判断dp[lena][lenb]是否等于

POJ 2192

1 #include <iostream> 2 #include <string> 3 #define MAXN 500 4 using namespace std; 5 6 bool dp[MAXN][MAXN]; 7 8 int main() 9 { 10 //freopen("acm.acm","r",stdin); 11 int test; 12 string s_1; 13 string s_2; 14 string s_3; 15

POJ 1194 Zipper 【dp】【北大ACM/ICPC竞赛训练】

现在做dp题有点感觉了,以前估计会觉得这题很难,现在觉得这是道不是很水的水题 dp[i][j]代表A里前i个加上B里前j个能不能组成C的前i+j个. 至于怎么想到的呢,n是200,有1000组数据,所以猜测要dp二维,然后很容易就想到了. 这里再考虑到C[i+j]的这个元素肯定是由A[i]或B[j]组成(即A的最末尾或B的最末尾,因为要保证原来的order) 所以这就变成了dp[i][j] = dp[i-1][j] | dp[i][j-1]  (当然这是A[i]=B[j]=C[i+j])的情况.